



<!DOCTYPE html><html lang=zh-CN><head><meta http-equiv="Content-Type" content="text/html; charset=utf-8" /><meta http-equiv="X-UA-Compatible" content="IE=edge,chrome=1"><meta name="applicable-device" content="pc,mobile"><meta name="renderer" content="webkit"><meta name="viewport" content="width=device-width,initial-scale=1.0,maximum-scale=5,viewport-fit=cover">
<title>ZOJ 2625 Rearrange Them（DP）</title>	
<script src="//n4.ikafan.com/assets/run_prettify.js?ac"></script>
<link rel="stylesheet" href="//n4.ikafan.com/assetsg/style.css">
<!-- <link rel="stylesheet" href="//pic.ikafan.com/staticx/shuzhiduo/1/css.grace/fontello.css?ac"> -->
<!-- <link rel="stylesheet" href="//pic.ikafan.com/staticx/shuzhiduo/1/css.grace/animation.css?ac"> -->
<script>
var _hmt = _hmt || [];
(function() {
  var hm = document.createElement("script");
  hm.src = "https://hm.baidu.com/hm.js?c61d51e9fdcf1d1631ddfce8df9cd119";
  var s = document.getElementsByTagName("script")[0]; 
  s.parentNode.insertBefore(hm, s);
})();
</script>
<script src="https://n4.ikafan.com/g/show.js"></script>

</head>
<div id="header" class="navbar navbar-default navbar-fixed-top header-01">
	<div class="container">
		<h1 class="logo">
			<a  href="/" title="巴特西"/>
							巴特西
			</a>
		</h1>
				<div role="navigation"  class="site-nav  primary-menu">
			<div class="menu-fix-box">
				 <ul id="menu-navigation" class="menu" >
<li><a href="/">首页</a></li>
<!-- <li><a href="/search/Hadoop/">Hadoop</a></li>
<li><a href="/search/Linux/">Linux</a></li>
<li><a href="/search/jQuery/">jQuery</a></li> -->
<li><a href="/search/Python/">Python</a></li>
<li><a href="/search/Java/">Java</a></li>
<li><a href="/search/PHP/">PHP</a></li>
<li><a href="/search/IOS/">IOS</a></li>
<li><a href="/search/Andorid/">Andorid</a></li>
<li><a href="/search/NodeJS/">NodeJS</a></li>
<li><a href="/search/JavaScript/">JavaScript</a></li>
<li><a href="/search/HTML5/">HTML5</a></li>
				</ul>					 			
			</div>
		</div>
				<!--<div class="right-nav">
				<button class="js-toggle-search"><i class="icon-search"></i></button>
		</div>-->
       
			</div>	
</div>

<div id="page-content">
	<div class="container">
		<div class="row">
			
			<div class="blog-post">
								<!--<div class="posts-top-cjtz clearfix"></div>-->
								<div class="post">
										<div class="post-title">
											<div id="title_top"></div>
<script>insertAdIfNeeded();</script>
						<h1 class="title">ZOJ 2625 Rearrange Them（DP）</h1>
						<div class="post_icon">
							<span class="icon-clock-1"> 2024-02-11 16:11:17 </span>
						</div>
										<div class="post-content">
													<div id="single_top"></div>
<script>insertAdIfNeeded();</script>
											
		<p>题目链接：<a href="http://acm.zju.edu.cn/onlinejudge/showProblem.do?problemId=1625" rel="external nofollow noreferrer">http://acm.zju.edu.cn/onlinejudge/showProblem.do?problemId=1625</a></p>
<p>题目大意：将n个数重新排列，使得每个数的前一个数都不能和之前的一样，求一共有多少种排列方法</p>
<p><strong>ample Input:</strong></p>
<pre class="prettyprint linenums">3<br />
4
</pre>
<p><strong>Sample Output:</strong></p>
<pre class="prettyprint linenums">3<br />
11</pre>
<p>分析：</p>
<p>　　CrazyAC's 解题报告：<br />　　本题一道ＤＰ题　仔细想想不难的<br />　　首先我们确定状态F[N]表示所产生的新排列的情况数<br />　　那么F[N]=f(F[N-1]) 怎么来确定他呢？<br />　　由于F[N-1]是排好了；所以只要把N往里插，唯一不可插的地方就是N-1后；所以共有N-1情况，<br />　　那么F[N]=(N-1)*F[N-1] (1)似乎这个式子就对了　但是自己手写几组数据是不对的　郁闷中啊～～～<br />　　但仔细想想肯定是漏情况了　在哪呢？原来是在我们已经排除的那些组合里，举个例子：N=3 <br />　　是有3种排列:1 3 2;2 1 3;3 2 1<br />　　那么N=4 时，如果只考虑1 3 2;2 1 3;3 2 1这3种就少情况了，原因出在2 3 1；3 1 2这两<br />　　个排列没考虑；只要在2 3 1中的2 3之间插4，在3 1 2中的1 2之间插4即可；由此可以发现<br />　　在(1)中要加一个参数g(N-1)其表示在N-1个数的排列中，有唯一一对原顺序的排列情况<br />　　g(N)如何确定？我们只要用捆绑一对数的思想就可以；举个例子：把1 2 3 4 5 6中的2 3看　<br />　　成一个数其等价与1 2 3 4 5，所以g(N)=h(F[N-1]),由于捆绑对数就是N-1,就是(1 2 ,2 3, 3 4...)<br />　　那么g(N)就确定了：g(N)=(N-1)*F[N-1]；所以完成状态方程：F[N]=(N-1)*F[N-1]+(N-2)*F[N-2];<br />　　注意边界条件F[0]=0 F[1]=0 F[2]=1 F[3]=3（要用大数）</p>
<p>代码如下：</p>
<div>
<pre class="prettyprint linenums"> #include &lt;stdio.h&gt;<br />
 #include &lt;string.h&gt;

 int f[][];

 void add(int a,int b,int c){<br />
     int i,car=,k;<br />
     for(i=;i&lt;=;i++){<br />
         k=b*f[b][i]+c*f[c][i]+car;<br />
         f[a][i]=k%;<br />
         car=k/;<br />
     }<br />
 }

 void DP(){<br />
     int i;<br />
     memset(f,,sizeof(f));<br />
     f[][]=;<br />
     f[][]=;<br />
     f[][]=;<br />
     f[][]=;<br />
     for(i=;i&lt;=;i++){<br />
         add(i,i-,i-);<br />
     }<br />
 }

 int main()<br />
 {<br />
     int i,j,n;<br />
     DP();<br />
     while(scanf("%d",&amp;n)!=EOF){<br />
         if(n== || n==){<br />
             printf("0\n");<br />
             continue;<br />
         }<br />
         for(i=;i&gt;=;i--)<br />
             if(f[n][i]) break;<br />
         for(j=i;j&gt;=;j--)<br />
             printf("%d",f[n][j]);<br />
         printf("\n");<br />
     }<br />
     return ;<br />
 }</pre>
</div>												<div id="single_bottom"></div>
<script>insertAdIfNeeded();</script>
																
<h2>最新文章</h2>	
<ol>
						<li><a href="https://www.batexi.com/a/1q2wwxxq.html">Atitit&period;http httpclient实践java c&num; &period;net php attilax总结</a>
		</li>
						<li><a href="https://www.batexi.com/a/r93wnpnq.html">解决微信公众号OAuth出现40029&lpar;invalid code，不合法的oauth&lowbar;code&rpar;的错误</a>
		</li>
						<li><a href="https://www.batexi.com/a/49gx1wzq.html">Android 创建一个新的Activity</a>
		</li>
						<li><a href="https://www.batexi.com/a/e9j755l9.html">&lbrack;Machine-Learning&rsqb; 熟悉 Numpy</a>
		</li>
						<li><a href="https://www.batexi.com/a/oqvyjdoq.html">Spring &mdash;&mdash;  三种配置数据源的方式：spring内置、c3p0、dbcp</a>
		</li>
						<li><a href="https://www.batexi.com/a/8ok4vk59.html">设计模式-单例模式&lpar;Singleton&rpar;</a>
		</li>
						<li><a href="https://www.batexi.com/a/q1zy7p29.html">javascript event兼容IE和FF</a>
		</li>
						<li><a href="https://www.batexi.com/a/8k16g769.html">经典SQL练习题</a>
		</li>
						<li><a href="https://www.batexi.com/a/qwj4n7k8.html">A Simple Math Problem（矩阵快速幂）（寒假闭关第一题，有点曲折啊）</a>
		</li>
						<li><a href="https://www.batexi.com/a/9gekx078.html">&lbrack;bx&rsqb;和loop指令</a>
		</li>
						<li><a href="https://www.batexi.com/a/8eyvvwk9.html">freetypeLCD显示</a>
		</li>
						<li><a href="https://www.batexi.com/a/q2jrylw8.html">Oracle Database 10g安装</a>
		</li>
						<li><a href="https://www.batexi.com/a/q25wgjvq.html">关于xampp mysql字符编码与编译器编码不匹配问题</a>
		</li>
						<li><a href="https://www.batexi.com/a/q4jm6m0q.html">Sliverlight常见错误集锦</a>
		</li>
						<li><a href="https://www.batexi.com/a/8kj231r9.html">虚拟现实外包公司&mdash;VR游戏你不知道的以及你该知道的WebVR</a>
		</li>
						<li><a href="https://www.batexi.com/a/9gjknpl9.html">OneProxy构建</a>
		</li>
						<li><a href="https://www.batexi.com/a/8kopde5q.html">jquery each循环遍历完再执行的方法  因为each是异步的 所以要加计数器&period;</a>
		</li>
						<li><a href="https://www.batexi.com/a/8koj52jq.html">Map的深浅拷贝的探究</a>
		</li>
						<li><a href="https://www.batexi.com/a/qvenv7y9.html">SQL之PROCEDURE（存储过程）</a>
		</li>
						<li><a href="https://www.batexi.com/a/q1v6dk6q.html">30&period;概述strust2中的拦截器</a>
		</li>
		</ol>
	

<h2>热门文章</h2>	
<ol>
									<li><a href="https://www.batexi.com/a/8k1ryn39.html">如何获得JVM执行过程中调用的方法名</a>
			</li>
						<li><a href="https://www.batexi.com/a/q1zwgk59.html">JNI-使用RegisterNatives注册本地方法</a>
			</li>
						<li><a href="https://www.batexi.com/a/8e1rp5m9.html">java 实现视频转换通用工具类：视频截图-Ffmpeg（四）</a>
			</li>
						<li><a href="https://www.batexi.com/a/96oz6yy9.html">Redis实战之征服 Redis &plus; Jedis &plus; Spring （二）</a>
			</li>
						<li><a href="https://www.batexi.com/a/qlmxek09.html">安装builderRobot到Rational Functional Tester和Performance Tester</a>
			</li>
						<li><a href="https://www.batexi.com/a/qxn4ndd8.html">IOS 图片阴影，圆角等处理</a>
			</li>
						<li><a href="https://www.batexi.com/a/93x6yor9.html">java nio 抛出NonWritableChannelException异常</a>
			</li>
						<li><a href="https://www.batexi.com/a/90v1r0j8.html">《RESTful Web Services》第四章 设计URI</a>
			</li>
						<li><a href="https://www.batexi.com/a/8ok21zp9.html">一、 Socket之UDP异步传输文件</a>
			</li>
						<li><a href="https://www.batexi.com/a/90v125j8.html">How to Map Distinct Value Types Using Java Generics--reference</a>
			</li>
			</ol>			
							
					</div>

					
<div class="next-prev-posts clearfix">
</div>
						 
				</div>
				
	<div class="clear"></div>

			</div>	
			

		</div>
</div>
</div>


<div class="clearfix"></div>
<div id="footer" class="two-s-footer">
	<div class="footer-box">
		<div class="container">
			<div class="row" style="padding-left: 15px;padding-right: 15px;">
			<div class="nav-footer">
				<a href="/">Home</a>
				</div>
				<div class="copyright-footer">
					<p>Powered By WordPress</p>
				</div>
							</div>
		</div>
	</div>
</div>
<div style="display:none">

</div>
<script src="//n4.ikafan.com/assets/js/echo.js"></script>
<script>
    echo.init({
      offset: 100,
      throttle: 250,
      unload: false,
      callback: function (element, op) {
        console.log(element, 'has been', op + 'ed')
      }
    });
 </script>
</body>
</html>
